<script setup lang="ts">
    import SContentContainer from '@/components/layout/SContentContainer.vue'
    import SContextualNavbar from '@/shared/navbar/components/SContextualNavbar.vue'
    import SFooter from '@/components/layout/SFooter.vue'
    import { ref, watch } from 'vue'
    import { emitSnackBar } from '@/plugins/snackBarManager'
    import { useRoute, useRouter } from 'vue-router'
    import { UserApi } from '@/api/user/UserApi'
    import { useMsal } from '@/plugins/msal/useMsal'
    import { User } from '@/api/user/User'
    import { SilabError } from '@/shared/errors/SilabError'
    import { userMapper } from '@/api/user/UserMapper'
    import { useConfigurationStore } from '../../stores/ConfigurationStore'
    import { useServiceOffers } from '@/serviceOffer/components/composables/serviceOffer/serviceOffers'
    import SUserForm from '../../components/users/SUserForm.vue'
    import { isDefined, isUndefined } from '@/shared/helpers/types'
    import { useBreadcrumb } from '@/shared/routing/composables/breadCrumb'
    import { useUserStore } from '@/shared/user/stores/UserStore'
    import SExpendableButton from '@/shared/button/components/SExpendableButton.vue'

    const router = useRouter()
    const { getParentRoute } = useBreadcrumb()

    const route = useRoute()

    const msal = useMsal()
    const userStore = useUserStore(msal)

    const userApi = new UserApi(msal)
    const userId = <string>route.params.id
    const user = ref<User | undefined>()

    const configurationStore = useConfigurationStore()
    const serviceOfferStore = useServiceOffers()

    const isLoading = ref(false)

    watch(
        [() => msal.accounts, () => userStore.isImpersonating],
        () => {
            isLoading.value = true
            userApi
                .get(userId)
                .then(async (fetchedUser) => {
                    user.value = fetchedUser
                })
                .catch((error) => {
                    throw new SilabError(
                        `Erreur lors du chargement de l'utilisateur à modifier`,
                        error
                    )
                })
                .finally(() => (isLoading.value = false))
            serviceOfferStore.loadServiceOffers(msal)
        },
        { immediate: true }
    )

    async function updateUser() {
        try {
            if (isUndefined(user.value)) {
                return
            }
            const updatedUserDto = userMapper.toEditDto(user.value)
            await userApi.update(user.value.id, updatedUserDto)

            emitSnackBar(
                `Utilisateur "${updatedUserDto.email}" a été mis à jour`,
                'primary'
            )
            router.push(getParentRoute())
        } catch (error) {
            emitSnackBar((<Error>error).message, 'error')
        }
    }
</script>
<template>
    <s-contextual-navbar page-title="Modifier un utilisateur">
        <template #contextualButtons>
            <s-expendable-button
                v-if="
                    isDefined(user) &&
                    userStore.userHasRole(
                        userStore.currentUser,
                        'ROLE_ALLOWED_TO_SWITCH'
                    )
                "
                label="Usurper"
                icon="mdi-ghost-outline"
                data-cy="impersonate-user"
                color="secondary"
                @click="userStore.impersonateUser(user.email)"
            >
            </s-expendable-button>
        </template>
    </s-contextual-navbar>
    <v-main>
        <s-content-container>
            <v-skeleton-loader
                v-if="isLoading"
                type="heading, heading, heading, actions"
            ></v-skeleton-loader>
            <s-user-form
                v-if="isDefined(user)"
                v-model="user"
                :configuration-store="configurationStore"
                :service-offer-store="serviceOfferStore"
                :is-processing="userApi.isProcessing.value"
                @submit.prevent="updateUser()"
            >
            </s-user-form>
        </s-content-container>
    </v-main>
    <s-footer />
</template>
